;SLIDESHOW ampliable, Version 2 by Metalbrain

N_S             EQU     18              ; Numero de pantallas
N_E             EQU     4               ; Numero de efectos
LD_BYTES        EQU     1366            ; Rutina de carga de la ROM

                ORG     32768   ; Direccion de comienzo del codigo

                ; Nucleo principal del slide-show

                XOR     A               ;Iniciar numero de pantalla a 0
                LD      (N_SCREEN),A    
EXTBUC:         XOR     A               ;Iniciar numero de efecto a 0
INTBUC:         LD      (N_EFFECT),A    ;Guardar efecto actual

                LD      DE,17           ;Cabecera, no hace falta en verdad
                LD      IX,49152        ;
                XOR     A               ;
                SCF                     ;Se puede suprimir quitando tambien 
                CALL    LD_BYTES        ; las cabeceras de las pantallas

                LD      DE,6912         ;Numero de bytes
                LD      IX,49152        ;Direccion de comienzo
                LD      A,255           ;Identificador de bloque
                SCF                     ;Carry flag a 1 para cargar
                CALL    LD_BYTES        ;Llamar a la rutina de carga

                LD      HL,TABLE-2
                LD      A,(N_EFFECT)    ; Seleccionar efecto
                INC     A
                LD      B,A
SELEFF:         INC     HL
                INC     HL
                DJNZ    SELEFF    

                LD      A,(HL)          ;Introducir efecto en la direccion
                INC     HL              ; a la que se llama con CALL
                LD      (THEJUMP1),A
                LD      A,(HL)
                LD      (THEJUMP2),A

THEJUMP:        DEFB    205             ;CALL
THEJUMP1:       DEFB    0
THEJUMP2:       DEFB    0

                LD      B,250           ; Pausa de 5 segundos, para que de tiempo a 
PPAUSE:         HALT                    ; ver las pantallas al usar emuladores con 
                DJNZ    PPAUSE          ; carga instantanea

                LD      A,(N_SCREEN)    ;Incrementar el contador de pantallas
                INC     A
                CP      N_S

                JR      Z,THEEND        ;Si se han visto todas ya, acabar
                LD      (N_SCREEN),A

                LD      A,(N_EFFECT)    ;Incrementar contador de efecto
                INC     A
                CP      N_E
                JR      Z,EXTBUC        ;Si se han usado todos, empezar de 0
                JR      INTBUC          ;Si no, usar el siguiente

THEEND:         XOR     A               ;Esperar pulsacion de tecla
WAITKEY:        IN      A,(254)
                CPL
                AND     31
                JR      Z,WAITKEY
                RET                     ;Volver al BASIC

                ;Variables del bucle principal del slideshow

N_EFFECT:       DEFB    0       
N_SCREEN:       DEFB    0

                ;Tabla de efectos

TABLE:          DEFW    EF1
                DEFW    EF2
                DEFW    EF3
                DEFW    EF4


        ; EF1: Efecto entrelazado de lineas, por Metalbrain

EF1_COUNT:      DEFB    0
EF1:            LD      A,56
                LD      HL,22528
                LD      DE,22529
                LD      (HL),A
                LD      BC,767
                LDIR                    ;Fijar los atributos

                LD      BC,1            ;BC = numero de caracteres que entran
                                        ; de cada linea en cada iteracion.
                                        ; Varia de 1 a 32, con 32 acabamos
                                        ; de mostrar toda la pantalla y por lo
                                        ; tanto llegar a 33 significa que
                                        ; el efecto ha terminado

EF1_EXTBUC:     LD      HL,49152+32     ;HL = direccion de origen en los
                                        ; movimientos de bytes, por lo que
                                        ; se situa en la zona de memoria
                                        ; donde hemos cargado la pantalla
                                        ; que tenemos que presentar

                                        ;Las lineas pares entran hacia la
                                        ; derecha, por lo que HL al principio
                                        ; apunta 32 bytes mas alla del
                                        ; comienzo de la pantalla. Asi al
                                        ; restar BC, conseguiremos el comienzo
                                        ; del extremo derecho que tenemos que
                                        ; pintar de la linea.

                LD      DE,16384        ;DE = destino en los movimientos de
                                        ; bytes, por lo que se situa en la
                                        ; zona de memoria correspondiente a
                                        ; la pantalla que aparece en la TV
                                        ;Al principio apunta justo al comienzo
                                        ; de la pantalla, pues es donde va a
                                        ; aparecer la primera linea.

                LD      A,96            ;96 parejas de lineas quedan por
                                        ; mover

EF1_INTBUC:     LD      (EF1_COUNT),A   ;Guardar la variable
                PUSH    HL              ;Guardar HL y DE en la pila
                PUSH    DE              ; para recuperarlos tras hacer
                PUSH    HL              ; los LDIRs
                PUSH    DE
                OR      A               ;Poner el Carry Flag a 0 para hacer
                                        ; que el SBC sea como un SUB
                SBC     HL,BC           ;Origen de los bytes que vamos a mover

                LD	A,C		;Preservar C
                LDIR                    ;Mover linea par, entrando por la
                                        ; izquierda hacia la derecha
		LD	C,A             ;Recuperar C

                POP     DE              ;Recuperar DE y HL
                POP     HL
                                        ;Las lineas impares entran por la
                                        ; derecha hacia la izquierda, de forma
                                        ; que tenemos que cambiar las
                                        ; posiciones relativas de DE y HL
                                        ; (aparte de hacer que bajen 1 linea
                                        ; y se coloquen en la impar)

                                        ;En este caso DE hay que colocarlo
                                        ; pasado el final de la linea y
                                        ; restarle BC para que obtenga su
                                        ; valor final

                EX      DE,HL           ;Intercambiamos DE y HL porque DE
                                        ; no permite realizar restas. En lugar
                                        ; de poner aqui esta instruccion, se
                                        ; podria haber puesto justo antes del
                                        ; SBC y operar en las siguientes
                                        ; 6 instrucciones con E y D. Lo mismo
                                        ; da una cosa que otra.

                LD      A,32            ;Sumamos 288 a HL, 32 para colocar
                ADD     A,L             ; al final de la linea y 256 para
                LD      L,A             ; bajar a la linea impar.
                LD      A,1
                ADC     A,H
                LD      H,A

                SBC     HL,BC           ;Restamos el numero de bytes a mover
                                        ; para acabar de ajustar la direccion

                EX      DE,HL           ;Y volvemos a dejar el resultado en DE

		LD	A,C		;Preservar valor de C
		LD	C,224		;Sumamos 224 a HL, lo cual es equivalente a 
		ADD	HL,BC		;restar los 32 que nos sobran y sumar 256 
					;para bajar una linea
		LD	C,A		;Recuperar valor de C
                LDIR                    ;Mover la linea impar
		LD	C,A		;Recuperar numero de bytes de nuevo

                POP     DE              ;Recuperar posiciones originales
                POP     HL              ; en pantalla y en memoria

                DEC     HL              ;hacer que la linea de HL sea par
                CALL    NEXT2_EXDEHL    ;Bajar 2 lineas para DE
                CALL    NEXT2_EXDEHL    ;Y otras 2 para HL

                INC     HL              ;recuperar el +32 que necesitamos

                LD      A,(EF1_COUNT)   ;Obtener cuenta de lineas
                DEC     A               ;Decrementar
                JR      NZ,EF1_INTBUC   ;Si no es cero, repetir el bucle
                                        ; interno para las 96 parejas de
                                        ; lineas

                HALT                    ;Pausa
                HALT                    

                INC     C              	;Incrementar numero de pixels a
                                        ; mostrar en la siguiente iteracion

                LD      A,C             ;Comparar con 33
                CP      33

                JR      NZ,EF1_EXTBUC   ;Continuar el bucle externo si es
                                        ; necesario

                LD      HL,49152+6144
                LD      DE,16384+6144
                LD      BC,768
                LDIR                    ;Mover los atributos
                RET                     ;Regresar a la rutina principal

NEXT2_EXDEHL:   INC     D     ; Incrementa 2 lineas + intercambio de HL y DE
NEXT_EXDEHL:    EX      DE,HL ; Incrementa 1 linea + intercambio de HL y DE

NEXT_HL:        INC     H       ;Incrementa 1 linea, si pasamos de caracter
                LD      A,H     ; se queda a 0 y se produce un aumento de
                                ; tercio
                AND     7
                RET     NZ      ;Salir si no hemos pasado de caracter
                LD      A,L
                ADD     A,32    ;Pasar al siguiente caracter
                LD      L,A
                RET     C       ;Salir si se produjo un cambio de tercio
                LD      A,H
                SUB     8       ;Quitar el aumento de tercio que no se produjo
                LD      H,A
                RET



        ; EF2: Efecto atributos espiral, por Metalbrain

EF2_COUNT:      DEFB    0
EF2:            LD      DE,16384+6144+1 ;Comienzo zona atributos + 1
                LD      HL,16384+6144   ;Comienzo zona atributos
                XOR     A               ;A = 0 (color negro)
                LD      (HL),A          ;Poner color negro en el primer
                                        ; caracter de la pantalla
                LD      BC,767          ;Numero de caracteres a borrar
                LDIR                    ;Poner pantalla en negro

                LD      DE,16384
                LD      HL,49152
                LD      BC,6144
                LDIR                    ;Copiar pixels


                LD      IX,1            ;Incremento horizontal
                LD      IY,32           ;Incremento vertical

                LD      HL,16383+6144   ;Iniciar HL = Zona de atributos-1
                LD      A,32            ;Contador inicial
                LD      (EF2_COUNT),A   ;Iniciar variable

EF2_EXTBUC:     LD      A,(EF2_COUNT)   ;Contador
                LD      B,A             ;B = numero de caracteres a desvelar

                PUSH    IX
                POP     DE              ;DE = IX = incremento horizontal

                CALL    EF2_BUC         ;Mostrar una linea horizontal de
                                        ; atributos

                PUSH    DE
                POP     IX              ;IX = DE

                LD      A,(EF2_COUNT)
                DEC     A            
                LD      (EF2_COUNT),A   ;Decrementar cuenta de bytes

                SUB     8               ;Restar 8 para obtener el numero
                                        ; de caracteres verticales para el
                                        ; siguiente paso

                JR      Z,EF2_END       ;Si salen 0, hemos acabado

                LD      B,A             ;B = numero de caracteres a desvelar

                PUSH    IY
                POP     DE              ;DE = IY = incremento vertical

                CALL    EF2_BUC         ;Mostrar linea vertical

                PUSH    DE
                POP     IY              ;IY = DE

                JR      EF2_EXTBUC      ;Repetir hasta salir


EF2_BUC:        ADD     HL,DE           ;Actualizar HL con el incremento
                                        ; que le corresponde

                SET     7,H             ;Hacer que HL apunte a la zona de
                                        ; memoria alta donde se almacena el
                                        ; grafico. Esto es posible hacerlo
                                        ; asi porque las direcciones de
                                        ; almacen y de pantalla solo se
                                        ; diferencian en un bit

                LD      A,(HL)          ;Tomar valor

                RES     7,H             ;Volver a apuntar a la pantalla

                LD      (HL),A          ;Escribir valor. Con esto desvelamos
                                        ; el caracter que habia oculto.

                LD      A,B             ;Hacer un HALT solo cada 8 caracteres
                AND     7               ; desvelados (hacerlo siempre
                JR      NZ,EF2_NOHALT   ; resultaria muy lento)
                HALT

EF2_NOHALT:     DJNZ    EF2_BUC         ;Mostrar todos los caracteres que se
                                        ; han pedido

                HALT                    ;Otro HALT

                LD      A,D             ;Negar el valor de DE, con lo cual
                CPL                     ; cambiamos el sentido la proxima
                LD      D,A             ; vez que avancemos 
                LD      A,E
                NEG
                LD      E,A

EF2_END:        RET                     ;Volver de la rutina EF2_BUC, o bien
                                        ; regresar a la rutina principal al
                                        ; acabar el efecto



        ; EF3: Efecto caracteres desordenados, por Metalbrain

EF3_FILLTABLE   EQU     49152-256       ; Tabla para el efecto 3
EF3_POINTER:    DEFW    0
EF3_COUNTER:    DEFB    0
EF3:            LD      B,0             ;Contador de 0 a 0 -> 256 iteraciones
                LD      HL,EF3_FILLTABLE;Tabla de relleno, para indicar que
                                        ; caracteres hemos volcado ya y cuales
                                        ; no
                XOR     A               ;Valor inicial para rellenar la tabla
                LD      (EF3_COUNTER),A ;Iniciar contador

EF3_FILLIT:     LD      (HL),A          ;Llenar la tabla

                INC     L
                DJNZ    EF3_FILLIT

                LD      IX,(EF3_POINTER);IX apunta a la ROM, de donde se toman
                                        ; los valores de incremento que
                                        ; indican cuantas posiciones libres
                                        ; tenemos que saltar en la tabla antes
                                        ; de quedarnos con una

EF3_EXTBUC:     LD      A,(EF3_COUNTER) ;Contador en A
                LD      B,A             ;Y en B

                AND     A               ;Ver si es 0

                LD      A,(IX+0)        ;Cargar en valor de incremento

                JR      Z,EF3_NOADJUST  ;Si B vale 0, equivale a 256 y no hay
                                        ; que ajustar el valor de incremento

EF3_ADJUST:     SUB     B               ;Restar el contador al valor de
                JR      NC,EF3_ADJUST   ; incremento hasta que obtengamos un
                ADD     A,B             ; acarreo, y entonces lo volvemos a
                                        ; sumar. Con eso logramos que el
                                        ; valor de incremento sea menor que
                                        ; el contador de posiciones libres,
                                        ; para no estar dandole vueltas a la
                                        ; tabla tontamente. En otras palabras,
                                        ; hacemos A = (A MOD B), la operacion
                                        ; del modulo

EF3_NOADJUST:   LD      B,A             ;El valor de incremento ajustado lo
                                        ; ponemos en B, para el bucle con DJNZ

                XOR     A               ;En A ponemos el valor a buscar: 0
                                        ; (no copiado todavia)
EF3_PARSE:      INC     L               ;Buscamos en la tabla B valores libres
                CP      (HL)
                JR      NZ,EF3_PARSE
                DJNZ    EF3_PARSE

                INC     (HL)            ;Marcamos el valor en la tabla

                PUSH    HL              ;Guardamos HL para mas tarde

                LD      H,128+88        ;Apuntamos a la zona de atributos
                                        ; origen

                LD      B,3             ;3 caracteres, uno por cada tercio

                INC     IX              ;Incrementamos IX para apuntar a un
                                        ; valor de incremento diferente en la
                                        ; ROM. Este INC puede colocarse en
                                        ; cualquier otra parte del programa

EF3_OTHERTHIRD: PUSH    BC
                PUSH    HL              ;Preservar registros

                LD      E,L             ;DE=HL-32768, misma direccion pero
                LD      A,H             ; en pantalla
                SUB     128
                LD      D,A

                LD      A,(HL)          ;Copiar atributo
                LD      (DE),A

                                        ;Pasar de direccion de atributos a
                                        ; direccion de pixels en DE y HL
                                        ;       A   Carry
                LD      A,D             ;010110tt       ?
                RLCA                    ;10110tt0       0
                RLA                     ;0110tt00       1
                RLCA                    ;110tt000       0
                LD      H,A
                AND     88              ;010tt000
                LD      D,A

                LD      B,8             ;8 bytes por caracter

EF3_DOCHAR:     LD      A,(HL)          ;Copiar byte de pixels
                LD      (DE),A

                INC     H               ;Apuntar a la siguientes lineas
                INC     D

                DJNZ    EF3_DOCHAR
                
                POP     HL              ;Recuperar HL
                POP     BC

                INC     H               ;Apuntar al siguiente tercio

                LD      A,49            ;Pequeno desplazamiento entre los
                ADD     A,L             ; caracteres que se muestran de cada
                LD      L,A             ; tercio, para que parezca mas
                                        ; aleatorio

                DJNZ    EF3_OTHERTHIRD  ;Repetir para los 3 tercios

                POP     HL              ;Recuperar direccion de la tabla

                LD      A,(EF3_COUNTER) ;Chequear la paridad del contador y
                AND     A               ; hacer un HALT solo cuando el
                JP      PE,EF3_NOHALT   ; contador tenga paridad impar. Por
                HALT                    ; termino medio, se hara una pausa
                                        ; cada 6 caracteres copiados

EF3_NOHALT:     DEC     A               ;Repetir hasta completar todos los
                LD      (EF3_COUNTER),A ; caracteres de la pantalla
                JR      NZ,EF3_EXTBUC

EF3_END:        LD      (EF3_POINTER),IX;Actualizar el puntero, asi si varias
                HALT                    ; pantallas usan este efecto, tendran
                RET                     ; patrones diferentes de aparicion
                                        ; de los caracteres

EF4:            LD      DE,16384+6144
                LD      HL,49152+6144
                LD      BC,3            ;Numero de tercios, B=0 para dar
                                        ; 256 vueltas con DJNZ

EF4_FLABRI:     LD      A,(HL)          ;Coger atributo
                AND     192             ;Dejar los bits de flash y bright
                LD      (DE),A          ;Fijar flash y bright
                INC     HL
                INC     DE
                DJNZ    EF4_FLABRI      ;Procesar caracteres del tercio
                DEC     C
                JR      NZ,EF4_FLABRI   ;Repetir para los 3 tercios

                LD      DE,16384
                LD      HL,49152
                LD      BC,6144
                LDIR                    ;Copiar pantalla menos atributos
                HALT
                LD      E,1             ;Heat actual en registro E
EF4_HEAT_EXT:   LD      HL,49152+6144   ;Apuntar al primer atributo
                LD      BC,3            ;C=3 tercios de B=0=256 caracteres
EF4_HEAT_INT:   LD      A,(HL)          ;Cargar atributo en A
                RES     7,H             ;Pasar a coordenada de pantalla
                AND     7               ;Aislar bits de tinta
                CP      E               ;Comparar con Heat actual
                CCF                     ;Invertir acarreo. Si CF=1, es que
EF4_NOINK:      LD      A,8             ; tenemos que incrementar la tinta
                ADC     A,(HL)          ; ademas del papel
                LD      (HL),A          ;
                SET     7,H             ;Recuperar posicion original
                INC     HL              ;Avanzar posicion
                DJNZ    EF4_HEAT_INT    ;Repetir tercio
                DEC     C
                JR      NZ,EF4_HEAT_INT ;Repetir los 3 tercios
                HALT
                HALT
                HALT
                HALT                    ;Pausa
                INC     E               ;Incrementar Heat
                LD      A,E
                CP      8
                JR      NZ,EF4_HEAT_EXT ;Si es menor que 8, seguir calentando

                LD      B,12            ;Pausa antes de pasar a enfriar el
EF4_PEAKPAUSE:  HALT                    ; el papel
                DJNZ    EF4_PEAKPAUSE

                LD      E,56            ;Cool a 7 (56 = 7*8)
EF4_COOL_EXT:   LD      HL,49152+6144   ;Apuntar al primer atributo
                LD      BC,3            ;como antes, CB = 768
EF4_COOL_INT:   LD      A,(HL)          ;Tomar atributo
                RES     7,H             ;Pasar a coordenada de pantalla
                AND     56              ;Aislar bits del papel
                CP      E               ;Comprobar si papel < Cool
                JR      NC,EF4_NOPAPER  ; si no lo es, no enfriamos
                LD      A,248           ;Sumar 248 es como restar 8
                ADD     A,(HL)          ;Enfriar papel
                LD      (HL),A
EF4_NOPAPER:    SET     7,H             ;Apuntar a la pantalla virtual
                INC     HL              ;Avanzar posicion
                DJNZ    EF4_COOL_INT
                DEC     C
                JR      NZ,EF4_COOL_INT ;Repetir bucle interno
                HALT
                HALT
                HALT
                HALT                    ;Pausa
                LD      A,E
                SUB     8               ;Bajar valor de Cool
                LD      E,A
                JR      NC,EF4_COOL_EXT ;Si no es 0, seguir enfriando
                RET                     ;Salir del efecto
